/*****************************************
monitor_ip.java
 
Lee un archivo de IP's (ips.txt) y las
monitorea por conexión sockets con hilos
para ver si estan funcionando
 
enero 2009 -  Rogelio Ferreira Escutia
****************************************/

import java.io.*;
import java.net.*;

public class monitor_ip {
	public static void main (String[] args) throws IOException, Exception {
		String ip;
		int contador=0;;
		System.out.println("\n***** Arrancando el Monitor de IP's *****\n");
		codigo_hilo_servidor hilo_servidor = new codigo_hilo_servidor("hilo servidor");
		hilo_servidor.start();
		System.out.println("Principal - Leyendo archivo de ip's");
		File mi_archivo = new File("ips.txt");
		try {
			BufferedReader in = new BufferedReader(new FileReader(mi_archivo));
			ip = in.readLine();contador=1;
			while (ip != null) {
				System.out.println("Principal - ip: " + ip);
				codigo_hilo_monitor hilo_monitor = new codigo_hilo_monitor(ip);
				hilo_monitor.start();
				ip = in.readLine();contador++;
			}
			in.close();
		} catch (FileNotFoundException e1) { System.out.println("Archivo no encontrado: " + mi_archivo); }
		System.out.println("Principal - Numero de servidores encontrados: "+(contador-1));
	}
}

class codigo_hilo_servidor extends Thread {
	public codigo_hilo_servidor (String nombre) { super(nombre); }
	public void run() {
		System.out.println("hilo_servidor - Arrancando Hilo para contestar en puerto 5000 el monitoreo de IP's ");
		try {
			ServerSocket servidor = new ServerSocket(5000);
			for (;;) { 
				Socket entrada = servidor.accept();
				codigo_hilo_atender_cliente hilo_atender_cliente = new codigo_hilo_atender_cliente(entrada);
				hilo_atender_cliente.start();
			}
		} catch (BindException be) { System.err.println ("Ya existe un servicio corriendo en este puerto: "+ 5000 );
		} catch (IOException ioe) { System.err.println ("Error de I/O error - " + ioe); }
	}   
}

class codigo_hilo_atender_cliente extends Thread {
	Socket entrada;
	public codigo_hilo_atender_cliente (Socket entrada) { this.entrada = entrada; }
	public void run() {
		try {
			System.out.println ("hilo_servidor - Recibiendo peticion de ip: " + entrada.getInetAddress() + " puerto: " + entrada.getPort() );
			OutputStream out = entrada.getOutputStream();
			PrintStream pout = new PrintStream (out);
			pout.print( new java.util.Date() );
			out.flush();
			out.close();
		} catch(Exception exc) { System.out.println("Error! - " + exc.toString()); }
		try {
			entrada.close();
		} catch(Exception exc) { System.out.println("Error! - " + exc.toString()); }
	}   
}

class codigo_hilo_monitor extends Thread {
	public codigo_hilo_monitor ( String nombre ) { super( nombre ); }
	public void run() {
		try {
			System.out.println("hilo_monitor - realizando conexion con ip: "+getName()+" puerto: 5000");
			Socket cliente = new Socket (getName(), 5000);
			System.out.println ("hilo_monitor - Conexion Establecida");
			cliente.setSoTimeout ( 2000 );
			BufferedReader leer = new BufferedReader(new InputStreamReader (cliente.getInputStream()));
			System.out.println ("hilo_monitor - Respuesta: " + leer.readLine());
			cliente.close();
		} catch (IOException ioe) { System.err.println ("Error " + ioe); }
	}   
}
